//Legal Notice: (C)2007 Altera Corporation. All rights reserved.  Your
//use of Altera Corporation's design tools, logic functions and other
//software and tools, and its AMPP partner logic functions, and any
//output files any of the foregoing (including device programming or
//simulation files), and any associated documentation or information are
//expressly subject to the terms and conditions of the Altera Program
//License Subscription Agreement or other applicable license agreement,
//including, without limitation, that your use is for the sole purpose
//of programming logic devices manufactured by Altera and sold by Altera
//or its authorized distributors.  Please refer to the applicable
//agreement for further details.

// synthesis translate_off
`timescale 1ns / 1ps
// synthesis translate_on

// turn off superfluous verilog processor warnings 
// altera message_level Level1 
// altera message_off 10034 10035 10036 10037 10230 10240 10030 

module el_camino_sd_card_controller (
                                      // inputs:
                                       CDn,
                                       DO,
                                       WP,
                                       clk,
                                       data_from_cpu,
                                       mem_addr,
                                       read_n,
                                       reset_n,
                                       spi_select,
                                       write_n,

                                      // outputs:
                                       CSn,
                                       DI,
                                       SCLK,
                                       data_to_cpu,
                                       dataavailable,
                                       endofpacket,
                                       irq,
                                       readyfordata
                                    )
;

  output           CSn;
  output           DI;
  output           SCLK;
  output  [ 15: 0] data_to_cpu;
  output           dataavailable;
  output           endofpacket;
  output           irq;
  output           readyfordata;
  input            CDn;
  input            DO;
  input            WP;
  input            clk;
  input   [ 15: 0] data_from_cpu;
  input   [  2: 0] mem_addr;
  input            read_n;
  input            reset_n;
  input            spi_select;
  input            write_n;

  wire             CSn;
  wire             DI;
  wire             SCLK;
  wire    [ 15: 0] data_to_cpu;
  wire             dataavailable;
  wire             endofpacket;
  wire             irq;
  wire             readyfordata;
  ip_sd_mmc_spi_wrapper the_ip_sd_mmc_spi_wrapper
    (
      .CDn           (CDn),
      .CSn           (CSn),
      .DI            (DI),
      .DO            (DO),
      .SCLK          (SCLK),
      .WP            (WP),
      .clk           (clk),
      .data_from_cpu (data_from_cpu),
      .data_to_cpu   (data_to_cpu),
      .dataavailable (dataavailable),
      .endofpacket   (endofpacket),
      .irq           (irq),
      .mem_addr      (mem_addr),
      .read_n        (read_n),
      .readyfordata  (readyfordata),
      .reset_n       (reset_n),
      .spi_select    (spi_select),
      .write_n       (write_n)
    );
  defparam the_ip_sd_mmc_spi_wrapper.ms_clock_divider = 60000,
           the_ip_sd_mmc_spi_wrapper.spi_clock_frequency = 20000000,
           the_ip_sd_mmc_spi_wrapper.system_clock_frequency = 60000000,
           the_ip_sd_mmc_spi_wrapper.target_clock_divider = 2;


endmodule

